/*****************************************************************************
 * Bison/Flexプログラム部分をテストするための、Windowsアプリケーションの雛型 *
 * □ビルド・実行方法:                                                       *
 * ┃"C:\Program Files (x86)\Microsoft Visual Studio\VC98\Bin\VCVARS32.BAT"  *
 * ┃make -f winapp.mk run                                                   *
 *****************************************************************************/
#include "winapp.h"
//-----------------------------------------------------------------------------
//警告定義
enum {
	WARN_CAST,			//暗黙の型変換で誤差が生じたら、警告を表示し最終的にエラー終了します。このオプションを指定しなければ、警告表示もエラー終了もしません。
};
static const char* const warn_tokens[]={
	"cast",				//暗黙の型変換で誤差が生じたら、警告を表示し最終的にエラー終了します。このオプションを指定しなければ、警告表示もエラー終了もしません。
NULL};//終端
int warn;				//各警告(WARN_*)について(warn&(1<<WARN_*))がセットされていたらその警告がOnである事を示します。
/*---------------------------------------------------------------------------*/
//ローカル変数定義
static ght_hash_table_t* ht_pSprFnt;	//スプライトフォントラベル⇒(ST_SprFnt*)
//ラベル名のソート方法
int (*fnLabCmp)(const void*, const void*) = strcmp;	//'n'オプションが指定されたらstrnatcmpに変更する。
//{{進捗表示用
static int opt_q;
static int newMsgLen, oldMsgLen = 0;
//}}進捗表示用
/*---------------------------------------------------------------------------*/
//エラーログ用
static char err_path[_MAX_PATH];	//'-e'オプションが指定されたら、エラーログファイル名を格納する。
static FILE* fp_err;			//最初のエラーログを記録する時に、エラーログファイルを作成する。
//{{2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
typedef struct _ST_Location {
	const char*	path;					//push_location()が呼び出された直前のファイル名
	int		line;					//push_location()が呼び出された直前の行番号
} ST_Location;
static ST_Location TBL_Location[16/*調整可*/];			//ロケーションスタック
static nLocation;						//ロケーションスタックの格納数
static const char* filename = "-";				//現在のファイル名(popen時はコマンド名)。現在の行番号はyylinenoを参照して下さい。
static void init_location(const char* path) {
	nLocation = 0;						//ロケーションスタックを空にする。
	filename = strdup(path);				//現在のファイル名をコピーして保持する。
	yylineno = 1;						//現在の行番号を初期化する。	yylex_init()でも初期化しているのでこの行は無くても構わないのだが、判り易さのためにここでも初期化する事にした。
}
void push_location(const char* path) {
	if(nLocation >= ARRAY_SIZE(TBL_Location)) { DIE(); }	//ロケーションスタックがフルでない事を確認する。
	TBL_Location[nLocation].path = filename;		//現在のファイル名をロケーションスタックに退避する。
	TBL_Location[nLocation].line = yylineno;		//現在の行番号をロケーションスタックに退避する。
	nLocation++;						//ロケーションスタックの格納数を増やす。
	filename = strdup(path);				//現在のファイル名をコピーして保持する。
	yylineno = 1;						//現在の行番号を初期化する。
}
void pop_location() {
	if(!nLocation) { DIE(); }				//ロケーションスタックが空でない事を確認する。
	nLocation--;						//ロケーションスタックの格納数を減らす。
	filename = TBL_Location[nLocation].path;		//現在のファイル名をロケーションスタックから復元する。
	yylineno = TBL_Location[nLocation].line;		//現在の行番号をロケーションスタックから復元する。
}
//}}2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
void yyerror(const char* fmt, ...) {	//←{{2015/03/06:'-e'オプション対応のためにwinapp.cから移動しました。}}
	//'-e'オプションが指定されていて、最初のエラーログを記録する時ならば…
	if(*err_path && !fp_err) {
		//エラーログファイルを作成する。
		fp_err = fopen(err_path, "w");
		if(!fp_err) { error(EXIT_FAILURE, errno, "%s が作成できません。", err_path); }	//{{2016/09/21変更:die(〜)で終了していた箇所を、error(EXIT_FAILURE,〜)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
		//エラーログファイルの出力ストリームは、バッファリング無しとする。
		// - die()で終了した時(abort()時)に、バッファ分がフラッシュされないようなので、こうしておく必要が有る。
		//   別の案として、この下の処理で毎回fflush()する方法も有るが、バッファリング無しとする方が簡単だろう。
		setbuf(fp_err, NULL);
	}
	//エラーメッセージ(,及び,エラーログ)を出力する。
//{{2016/09/24変更:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
//	             fprintf(stderr, "### error at line %d : ", yylineno);	//エラーメッセージ
//	if(fp_err) { fprintf(fp_err, "### error at line %d : ", yylineno); }	//エラーログ
//↓2016/09/24変更:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
	             fprintf(stderr, "%s(%d) : ", filename, yylineno);		//エラーメッセージ
	if(fp_err) { fprintf(fp_err, "%s(%d) : ", filename, yylineno); }	//エラーログ
//}}2016/09/24変更:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
	{
		va_list ap;
		va_start(ap, fmt);
		             vfprintf(stderr, fmt, ap);		//エラーメッセージ
		if(fp_err) { vfprintf(fp_err, fmt, ap); }	//エラーログ
		va_end(ap);
	}
	             fputc('\n', stderr);	//エラーメッセージ
	if(fp_err) { fputc('\n', fp_err); }	//エラーログ
}
/*---------------------------------------------------------------------------*/
//ローカル関数宣言
__declspec(noreturn) static void usage();
static int subr(int argc, char* argv[]);
static void pass2(int bOptimize);
static void output(const char* sRegOut);
static void output_reg(FILE* fp);
/*---------------------------------------------------------------------------*/
int main(int argc, char* argv[]) {
	int exitCode;
	SEH_init();
	exitCode = subr(argc, argv);
	return exitCode;
}
/*---------------------------------------------------------------------------*/
static int subr(int argc, char* argv[]) {
	int opt, bOptimize = 1;		//'-d'オプションが指定されなければ最適化を行う。
	const char* sRegOut = NULL;	//'-r'オプションが指定されたらレジストリスクリプトのファイル名,又は,"-"(標準出力)を設定する。
#if     (YYDEBUG!=0)
//	yydebug = 1; //nonzero means print parse trace
#endif/*(YYDEBUG!=0)*/
	//コマンドラインオプションを処理する。
	opterr = 0; //オプションエラーは当プログラム内で処理するので、getopt()内でのエラー表示は不要。
	while((opt = getopt(argc, argv, "dr::enw::qh")) != -1) {
		switch(opt) {
		case 'd':
			bOptimize = 0;				//最適化を行わない。
			break;
		case 'r':
			sRegOut = optarg ? optarg : "-";	//レジストリスクリプトのファイル名,又は,"-"(標準出力)を設定する。
			break;
		case 'e':
			{
				//エラーログファイル名を作成する。
				// - カレントフォルダに'実行ファイル名.err'という名前で生成する事にした。この動作は、'lk33.exe'の仕様を参考にした。
				char fname[_MAX_FNAME];
				_splitpath(argv[0], NULL, NULL, fname, NULL);
				_makepath(err_path, NULL, NULL, fname, ".err");
				//'-e'オプションが指定されたら、最初に確実に、既存のエラーログファイルを削除しておく。
				//前回に生成したエラーログが残っていて、今回生成したエラーログと混同する危険を避けるためである。
				//尚、'-e'オプションが指定されなかった場合は、既存のエラーログファイルを削除する処理は行わない。
				remove(err_path);
			}
			break;
		case 'n':
			fnLabCmp = strnatcmp;	//ラベル名のソートにstrnatcmp()を使用する。
			break;
		case 'w':
			if(optarg) {
				char *optionp = optarg, *valuep;
				while(*optionp) {
					switch(getsubopt(&optionp, (char* const*)warn_tokens, &valuep)) {
					case WARN_CAST:
						if(valuep) { usage(); }
						warn |= (1<<WARN_CAST);
						break;
					default:
						usage();
					}
				}
			} else {
				warn = -1;
			}
			break;
		case 'q':
			opt_q = 1;
			break;
		case 'h':
		default:
			usage();
		}
	}
	//ハッシュテーブルを作成する。
	ght_set_rehash((ht_pSprFnt = ght_create(0)), 1);
	//--- 1パス目の処理 ---
	//ファイルが指定されていなければ、標準入力から読み込む。
	if(optind == argc) {
		init_location("-");	//{{2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。}}
		yylex_init(stdin);
		if((yyparse() != 0) /*|| (yynerrs != 0)*/) { error(EXIT_FAILURE, 0, "エラーが発生しました。"); }	//{{2016/09/21変更:die(〜)で終了していた箇所を、error(EXIT_FAILURE,〜)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
	//ファイルが指定されていたら、各ファイルを読み込む。
	} else {
		int i;
		for(i = optind; i < argc; i++) {
			FILE* fp = fopen(argv[i], "r");
			if(!fp) { error(EXIT_FAILURE, errno, "%s が開けません。", argv[i]); }	//{{2016/09/21変更:die(〜)で終了していた箇所を、error(EXIT_FAILURE,〜)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
			init_location(argv[i]);	//{{2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。}}
			yylex_init(fp);
//{{2017/03/16変更:複数の入力ファイルを指定した時に、最後以外のファイルでエラーが発生した場合、当ツールの終了ステータスが0になっていたバグを修正しました。
//			if((yyparse() != 0) /*|| (yynerrs != 0)*/) { error(EXIT_FAILURE, 0, "%s: エラーが発生しました。", argv[i]); }	//{{2016/09/21変更:die(〜)で終了していた箇所を、error(EXIT_FAILURE,〜)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
//↓2017/03/16変更:複数の入力ファイルを指定した時に、最後以外のファイルでエラーが発生した場合、当ツールの終了ステータスが0になっていたバグを修正しました。
			{
				int save_yynerrs = yynerrs;	//yyparse()がyynerrsをクリアするので、その前に現在のyynerrsを保存しておく。
				if((yyparse() != 0) /*|| (yynerrs != 0)*/) { error(EXIT_FAILURE, 0, "%s: エラーが発生しました。", argv[i]); }	//{{2016/09/21変更:die(〜)で終了していた箇所を、error(EXIT_FAILURE,〜)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
				yynerrs += save_yynerrs;	//今回のyyparse()が0から数えたであろうyynerrsに対して、先ほど保存しておいたyynerrsを足し込む。
			}
//}}2017/03/16変更:複数の入力ファイルを指定した時に、最後以外のファイルでエラーが発生した場合、当ツールの終了ステータスが0になっていたバグを修正しました。
			fclose(fp);
		}
	}
    //{{進捗表示用
	if(!opt_q) {
		newMsgLen = fprintf(stderr, "\rpass1 ok");
		if(oldMsgLen > newMsgLen) { fprintf(stderr, "%*s", oldMsgLen - newMsgLen, ""); } putc('\n', stderr); oldMsgLen = 0;
	}
    //}}進捗表示用
	//1パス目の処理でエラーが発生しても、2パス目の処理を行って、全てのセマンティクスエラーを報告する。
	//--- 2パス目の処理 ---
	//2パス目の処理を行う。
	pass2(bOptimize);
    //{{進捗表示用
	if(!opt_q) {
		newMsgLen = fprintf(stderr, "\rpass2 ok");
		if(oldMsgLen > newMsgLen) { fprintf(stderr, "%*s", oldMsgLen - newMsgLen, ""); } putc('\n', stderr); oldMsgLen = 0;
	}
    //}}進捗表示用
	if(yynerrs != 0) { error(EXIT_FAILURE, 0, "エラーが発生しました。"); }	//1パス目,又は,2パス目の処理でエラーが発生していたら、出力処理を行わない。	//{{2016/09/21変更:die(〜)で終了していた箇所を、error(EXIT_FAILURE,〜)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
	//--- 出力処理 ---
	//出力処理を行う。
	output(sRegOut);
	if(yynerrs != 0) { error(EXIT_FAILURE, 0, "エラーが発生しました。"); }	//{{2016/09/21変更:die(〜)で終了していた箇所を、error(EXIT_FAILURE,〜)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
	return EXIT_SUCCESS;
}
/*---------------------------------------------------------------------------*/
//使い方を表示して終了する。
__declspec(noreturn) static void usage() {
	fprintf(stderr, "dSprFntC - スプライトフォント定義コンパイラ (%s)\n", VERSION);
	fprintf(stderr, "Copyright (C) 2017-2018 Naoyuki Sawa\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "USAGE:\n");
	fprintf(stderr, "  dSprFntC [option ...] [filename ...] \n");
	fprintf(stderr, "  ・filenameを指定しなければ、標準入力から読み込みます。\n");
	fprintf(stderr, "  ・filenameは、ワイルドカードによる複数指定も可能です。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "OPTIONS:\n");
	fprintf(stderr, "  -d             最適化を行いません。\n");
	fprintf(stderr, "                 このオプションを指定しなければ、最適化を行います。\n");
	fprintf(stderr, "  -r[ファイル名] レジストリスクリプトを、ファイルへ出力します。\n");
	fprintf(stderr, "                 ファイル名を指定しなければ、標準出力へ出力します。\n");
	fprintf(stderr, "                 このオプションを指定しなければ、レジストリスクリプトを出力しません。\n");
	fprintf(stderr, "  -e             エラーログファイルを生成します。\n");
	fprintf(stderr, "                 このオプションを指定しても、エラーが発生しなければ生成されません。\n");
	fprintf(stderr, "  -n             ラベル名のソートに、strnatcmp()を使用します。\n");
	fprintf(stderr, "                 このオプションを指定しなければ、strcmp()を使用します。\n");
	fprintf(stderr, "  -w             全ての警告を有効にします。\n");
	fprintf(stderr, "                 このオプションを指定しなければ、個別に設定した警告のみが有効になります。\n");
	fprintf(stderr, "  -wcast         暗黙の型変換で誤差が生じたら、警告を表示し最終的にエラー終了します。\n");
	fprintf(stderr, "                 このオプションを指定しなければ、警告表示もエラー終了もしません。\n");
	fprintf(stderr, "  -q             進捗表示を抑制します。\n");
	fprintf(stderr, "  -h             使い方を表示します。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "EXAMPLE:\n");
	fprintf(stderr, "  dSprFntC.exe -rRegSprFnt.txt SprFnt.txt\n");
	fprintf(stderr, "  SprFnt.txtをコンパイルします。\n");
	fprintf(stderr, "  レジストリスクリプトを、RegSprFnt.txtへ出力します。\n");
	exit(EXIT_FAILURE);
}
/*---------------------------------------------------------------------------*/
//1パス目の処理
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
int cast_dbl_to_int(double d) {
	int i = d;
	if(i != d) {
		if(warn & (1<<WARN_CAST)) {
			yyerror("切り捨て誤差が発生しました: %f → %d", d, i);
			yynerrs++;	//呼び出し元(main)に知らせるために。
			//全てのセマンティクスエラーを報告するために継続する。
		}
	}
	return i;
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void addSprFnt(ST_SprFnt* pSprFnt) {
	char* pSprFntLabel = pSprFnt->pSprFntHdr->pSprFntLabel;
    //{{進捗表示用
	if(!opt_q) {
		newMsgLen = fprintf(stderr, "\rpass1 %s", pSprFntLabel);
		if(oldMsgLen > newMsgLen) { fprintf(stderr, "%*s", oldMsgLen - newMsgLen, ""); } oldMsgLen = newMsgLen;
	}
    //}}進捗表示用
	//このシンボルを登録する。
	if(ght_insert(ht_pSprFnt,
		       pSprFnt,
		strlen(pSprFntLabel) + 1/*nul*/,
		       pSprFntLabel)) {
		yyerror("スプライトフォントラベルが重複しています。(%s)", pSprFntLabel);
		yynerrs++;	//呼び出し元(main)に知らせるために。
		return;		//全てのセマンティクスエラーを報告するために継続する。
	}
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
//文字列が、1バイト文字一文字,又は,2バイト文字一文字である事を確認し、文字コード(1〜0xFFFF)を返す。
//そうでなければエラーとして0を返す。
//{{2017/04/12変更:文字コードを、文字列だけでなく、数値でも指定出来るようにしました。
//int SprFntChar_New(char* pSprFntChar) {
//↓2017/04/12変更:文字コードを、文字列だけでなく、数値でも指定出来るようにしました。
int SprFntChar_NewStr(char* pSprFntChar) {
//}}2017/04/12変更:文字コードを、文字列だけでなく、数値でも指定出来るようにしました。
	int iSprFntChar;
	if(!pSprFntChar) { DIE(); }	//バグ
	//1バイト文字一文字,又は,2バイト文字一文字を取得する。
	iSprFntChar = mbsnextc(pSprFntChar);
	if(!iSprFntChar ||			//一文字目が無いか、
	   mbsnextc(mbsinc(pSprFntChar))) {	//二文字目が有れば、エラー。
		yyerror("文字列は、1バイト文字一文字,又は,2バイト文字一文字でなければいけません。(%s)", pSprFntChar);
		yynerrs++;	//呼び出し元(main)に知らせるために			//必要。YYERRORマクロ呼び出しでyynerrsは増やされないようだ。	←←←←←←←←←←■■■■重要■■■■
		return 0;	//y.tab.yの処理でYYERRORを行う。
	}
	return iSprFntChar;
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
//{{2017/04/12追加:文字コードを、文字列だけでなく、数値でも指定出来るようにしました。
//文字コードが、1〜0xFFFFの範囲である事を確認し、文字コード(1〜0xFFFF)を返す。
//そうでなければエラーとして0を返す。
int SprFntChar_NewVal(int iSprFntChar) {
	if((iSprFntChar < 1) || (iSprFntChar > 0xFFFF)) {
		yyerror("文字コードは、1〜0xFFFFの範囲でなければいけません。(%d)", iSprFntChar);
		yynerrs++;	//呼び出し元(main)に知らせるために			//必要。YYERRORマクロ呼び出しでyynerrsは増やされないようだ。	←←←←←←←←←←■■■■重要■■■■
		return 0;	//y.tab.yの処理でYYERRORを行う。
	}
	return iSprFntChar;
}
//}}2017/04/12追加:文字コードを、文字列だけでなく、数値でも指定出来るようにしました。
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
//1〜0xFFFFの範囲外ならばエラーとして0を返す。
//エラーでなければそのままの値を返す。
int SprNo_New(int iSprNo) {
	if((iSprNo < 1) || (iSprNo > USHRT_MAX)) {
		yyerror("スプライト番号が範囲外です。(%d)", iSprNo);
		yynerrs++;	//呼び出し元(main)に知らせるために			//必要。YYERRORマクロ呼び出しでyynerrsは増やされないようだ。	←←←←←←←←←←■■■■重要■■■■
		return 0;	//y.tab.yの処理でYYERRORを行う。
	}
	return iSprNo;
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
//符号付き24ビットの範囲外ならばエラーとして-1を返す。
//エラーでなければ符号無し24ビット値にマスクして返す。
//有効な値-1は上位8ビットがマスクされて符号無し24ビットの最大値になるので、有効な値-1と値が省略された事を示す-1を混同する危険は無い。
int Value_New(int iValue) {
	if((iValue < INT24_MIN) || (iValue > INT24_MAX)) {
		yyerror("値が範囲外です。(%d)", iValue);
		yynerrs++;	//呼び出し元(main)に知らせるために			//必要。YYERRORマクロ呼び出しでyynerrsは増やされないようだ。	←←←←←←←←←←■■■■重要■■■■
		return -1;	//y.tab.yの処理でYYERRORを行う。
	}
	return iValue & UINT24_MAX;	//エラーでなければ符号無し24ビット値にマスクして返す。
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
ST_SprFnt* SprFnt_New(struct _ST_SprFntHdr* pSprFntHdr, struct _ST_SprFntBody* pSprFntBody) {
	ST_SprFnt* pSprFnt = calloc(1, sizeof(ST_SprFnt));
	if(!pSprFnt) { DIE(); }	//メモリ不足
	if(!pSprFntHdr || !pSprFntBody) { DIE(); }	//バグ
	pSprFnt->pSprFntHdr	= pSprFntHdr;
	pSprFnt->pSprFntBody	= pSprFntBody;
	return pSprFnt;
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
ST_SprFntHdr* SprFntHdr_New(char* pSprFntLabel, int iNextX, int iNextY, int iDrawX, int iDrawY) {
	ST_SprFntHdr* pSprFntHdr = calloc(1, sizeof(ST_SprFntHdr));
	if(!pSprFntHdr) { DIE(); }	//メモリ不足
	if(!pSprFntLabel ||
	   ((iNextX < -1) || (iNextX > UINT24_MAX)) ||
	   ((iNextY < -1) || (iNextY > UINT24_MAX)) ||
	   ((iDrawX < -1) || (iDrawX > UINT24_MAX)) ||
	   ((iDrawY < -1) || (iDrawY > UINT24_MAX))) { DIE(); }	//バグ
	pSprFntHdr->pSprFntLabel	= pSprFntLabel;
	pSprFntHdr->iNextX		= (iNextX != -1) ? iNextX : 0;
	pSprFntHdr->iNextY		= (iNextY != -1) ? iNextY : 0;
	pSprFntHdr->iDrawX		= (iDrawX != -1) ? iDrawX : 0;
	pSprFntHdr->iDrawY		= (iDrawY != -1) ? iDrawY : 0;
	return pSprFntHdr;
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
ST_SprFntBody* SprFntBody_New(struct _ST_SprFntRow* pSprFntRow) {
	ST_SprFntBody* pSprFntBody = calloc(1, sizeof(ST_SprFntBody));
	if(!pSprFntBody) { DIE(); }	//メモリ不足
	ght_set_rehash((pSprFntBody->ht_pSprFntRow = ght_create(0)), 1);
	return SprFntBody_AddRow(pSprFntBody, pSprFntRow);
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
ST_SprFntBody* SprFntBody_AddRow(ST_SprFntBody* pSprFntBody, struct _ST_SprFntRow* pSprFntRow) {
	if(!pSprFntBody || !pSprFntRow) { DIE(); }	//バグ
	if(ght_insert(pSprFntBody->ht_pSprFntRow,
		       pSprFntRow,
		sizeof(pSprFntRow->iSprFntChar),
		      &pSprFntRow->iSprFntChar)) {
		if(!pSprFntRow->iSprFntChar) {
			yyerror("フォールバック用の描画設定が重複しています。");
		} else if(pSprFntRow->iSprFntChar <= UCHAR_MAX) {
			yyerror("文字コード\\x%02Xの描画設定が重複しています。", pSprFntRow->iSprFntChar);
		} else {
			yyerror("文字コード\\x%04Xの描画設定が重複しています。", pSprFntRow->iSprFntChar);
		}
		yynerrs++;	//呼び出し元(main)に知らせるために			//必要。YYERRORマクロ呼び出しでyynerrsは増やされないようだ。	←←←←←←←←←←■■■■重要■■■■
		return NULL;	//y.tab.yの処理でYYERRORを行う。
	}
	return pSprFntBody;
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
ST_SprFntRow* SprFntRow_New(int iSprFntChar, int iSprNo, int iNextX, int iNextY, int iDrawX, int iDrawY) {
	ST_SprFntRow* pSprFntRow = calloc(1, sizeof(ST_SprFntRow));
	if(!pSprFntRow) { DIE(); }	//メモリ不足
	if(((unsigned)iSprFntChar > USHRT_MAX) ||
	   ((unsigned)iSprNo      > USHRT_MAX) ||
	   ((iNextX < -1) || (iNextX > UINT24_MAX)) ||
	   ((iNextY < -1) || (iNextY > UINT24_MAX)) ||
	   ((iDrawX < -1) || (iDrawX > UINT24_MAX)) ||
	   ((iDrawY < -1) || (iDrawY > UINT24_MAX))) { DIE(); }	//バグ
	pSprFntRow->iSprFntChar	= iSprFntChar;
	pSprFntRow->iSprNo	= iSprNo;
	pSprFntRow->iNextX	= iNextX;
	pSprFntRow->iNextY	= iNextY;
	pSprFntRow->iDrawX	= iDrawX;
	pSprFntRow->iDrawY	= iDrawY;
	return pSprFntRow;
}
/*---------------------------------------------------------------------------*/
//2パス目の処理
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
static int Label_compar(LIST_ENTRY* _x, LIST_ENTRY* _y) {
	//当関数の処理は、ght_hash_table.h/cモジュールの動作に依存しています。
	//外部からght_hash_table_t.le_iteratorの順番を並び替えても、動作上問題有りません。
	ght_hash_entry_t* x = CONTAINING_RECORD(_x, ght_hash_entry_t, le_iterator);
	ght_hash_entry_t* y = CONTAINING_RECORD(_y, ght_hash_entry_t, le_iterator);
	return (*fnLabCmp)(x->key_data, y->key_data);
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
static int SprFntChar_compar(LIST_ENTRY* _x, LIST_ENTRY* _y) {
	//当関数の処理は、ght_hash_table.h/cモジュールの動作に依存しています。
	//外部からght_hash_table_t.le_iteratorの順番を並び替えても、動作上問題有りません。
	ght_hash_entry_t* x = CONTAINING_RECORD(_x, ght_hash_entry_t, le_iterator);
	ght_hash_entry_t* y = CONTAINING_RECORD(_y, ght_hash_entry_t, le_iterator);
	int iSprFntChar1 = *(int*)&x->key_data;
	int iSprFntChar2 = *(int*)&y->key_data;
	return iSprFntChar1 - iSprFntChar2;	//0〜0xFFFFの範囲なのでオーバーフローの心配は無いので減算で比較出来る。
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
static int SprFntRow_compar(const void* a, const void* b) {
	const ST_SprFntRow* pSprFntRow1 = a;
	const ST_SprFntRow* pSprFntRow2 = b;
	if(pSprFntRow1->iSprFntChar < pSprFntRow2->iSprFntChar) { return -1; }
	if(pSprFntRow1->iSprFntChar > pSprFntRow2->iSprFntChar) { return  1; }
	                                                        { return  0; }
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
static void pass2(int bOptimize) {
	//スプライトフォントをラベルの昇順にソートする。		//■■■注意：ght_hash_table_tの実装依存の処理です。■■■
	// - 意味上の影響は有りません。出力テキストの見易さのためだけです。
	//   スプライトフォントラベルはレジストリコンパイラによって値が割り振られるので、順番は関係無いからです。
	SortList(&ht_pSprFnt->le_iterator, Label_compar);
	{
		ght_iterator_t it;
		ST_SprFnt* pSprFnt;
		//各スプライトフォントについて…
		for(pSprFnt = ght_first(ht_pSprFnt, &it, NULL);
		    pSprFnt;
		    pSprFnt = ght_next( ht_pSprFnt, &it, NULL)) {
			ST_SprFntHdr*  pSprFntHdr  = pSprFnt->pSprFntHdr;
			ST_SprFntBody* pSprFntBody = pSprFnt->pSprFntBody;
			{
				//各スプライトフォント行を文字コードの昇順にソートする。		//■■■注意：ght_hash_table_tの実装依存の処理です。■■■
				// - 意味上の影響は有りません。出力テキストの見易さのためだけです。
				//   レジストリコンパイラによって文字コードの昇順に出力されるので、順番は関係無いからです。
				SortList(&pSprFntBody->ht_pSprFntRow->le_iterator, SprFntChar_compar);
			}
		}
	}
}
/*---------------------------------------------------------------------------*/
//出力処理
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
static void output(const char* sRegOut) {
	int nOut = 0;
	//レジストリスクリプトのファイル名,又は,"-"(標準出力)が指定されていたら…
	if(sRegOut) {
		FILE* fp = strcmp(sRegOut, "-") ? fopen(sRegOut, "w") : stdout;
		if(!fp) { error(EXIT_FAILURE, errno, "%s が作成出来ません。", sRegOut); }	//{{2016/09/21変更:die(〜)で終了していた箇所を、error(EXIT_FAILURE,〜)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
		output_reg(fp);
		if(fp != stdout) { fclose(fp); }
		nOut++;
	}
	if(!nOut) {
		fprintf(stderr, "-rオプションが指定されなかったので、出力を行いませんでした。\n");
	}
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
//レジストリスクリプトを出力する。
static void output_reg(FILE* fp) {
	fprintf(fp, "%s\t\t\t\t\t#//\t%s\n", "SprFnt", "SprFnt");
	{
		ght_iterator_t it1;
		ST_SprFnt* pSprFnt;
		//各スプライトフォントについて…
		for(pSprFnt = ght_first(ht_pSprFnt, &it1, NULL);
		    pSprFnt;
		    pSprFnt = ght_next( ht_pSprFnt, &it1, NULL)) {
			ST_SprFntHdr*  pSprFntHdr  = pSprFnt->pSprFntHdr;
			ST_SprFntBody* pSprFntBody = pSprFnt->pSprFntBody;
//{{2017/03/20変更:スプライトフォントラベルの一文字がCシンボル文字でなかった場合、先頭に「`」を付けてレジストリスクリプトに出力するように修正しました。
//			fprintf(fp, "\t%s\t\t\t\t#//\t\t%s\n", pSprFntHdr->pSprFntLabel, pSprFntHdr->pSprFntLabel);
//↓2017/03/20変更:スプライトフォントラベルの一文字がCシンボル文字でなかった場合、先頭に「`」を付けてレジストリスクリプトに出力するように修正しました。
			if(iscsymf(*pSprFntHdr->pSprFntLabel)) {
				fprintf(fp, "\t%s\t\t\t\t#//\t\t%s\n", pSprFntHdr->pSprFntLabel, pSprFntHdr->pSprFntLabel);
			} else {
				fprintf(fp, "\t`%s\t\t\t\t#//\t\t%s\n", pSprFntHdr->pSprFntLabel, pSprFntHdr->pSprFntLabel);
			}
//}}2017/03/20変更:スプライトフォントラベルの一文字がCシンボル文字でなかった場合、先頭に「`」を付けてレジストリスクリプトに出力するように修正しました。
			{
				//パース処理においては、値が省略されたら(=Value_New()が-1)を返したら)0とする。
				//出力処理においては、値が省略されたか又は明示的に0が指定された事によってこのフィールドが0ならば、当ツールはiNextXをレジストリテーブルに出力しない。
				//実行時は、レジストリテーブルに値が格納されていなければ0と見なす(データ削減のためです)。
				//レジストリテーブルに値が格納されていた場合は、取得した値のbit23を符号拡張して元の値に戻せ。
				if(pSprFntHdr->iNextX) { fprintf(fp, "\t\t%d\t= %d\t\t#//\t\t\t%s\t= %d\n", SprFnt_NextX, pSprFntHdr->iNextX, "NextX", pSprFntHdr->iNextX << 8 >> 8); }
				if(pSprFntHdr->iNextY) { fprintf(fp, "\t\t%d\t= %d\t\t#//\t\t\t%s\t= %d\n", SprFnt_NextY, pSprFntHdr->iNextY, "NextY", pSprFntHdr->iNextY << 8 >> 8); }
				if(pSprFntHdr->iDrawX) { fprintf(fp, "\t\t%d\t= %d\t\t#//\t\t\t%s\t= %d\n", SprFnt_DrawX, pSprFntHdr->iDrawX, "DrawX", pSprFntHdr->iDrawX << 8 >> 8); }
				if(pSprFntHdr->iDrawY) { fprintf(fp, "\t\t%d\t= %d\t\t#//\t\t\t%s\t= %d\n", SprFnt_DrawY, pSprFntHdr->iDrawY, "DrawY", pSprFntHdr->iDrawY << 8 >> 8); }
			}
			{
				ght_iterator_t it2;
				ST_SprFntRow* pSprFntRow;
				//各スプライトフォント行について…
				for(pSprFntRow = ght_first(pSprFntBody->ht_pSprFntRow, &it2, NULL);
				    pSprFntRow;
				    pSprFntRow = ght_next( pSprFntBody->ht_pSprFntRow, &it2, NULL)) {
					if(!pSprFntRow->iSprFntChar) {
						fprintf(fp, "\t\t%d\t\t\t#//\t\t\t%s\n", pSprFntRow->iSprFntChar, "fallback");
					} else if(pSprFntRow->iSprFntChar <= UCHAR_MAX) {
						fprintf(fp, "\t\t0x%02X\t\t\t#//\t\t\t0x%02X\n", pSprFntRow->iSprFntChar, pSprFntRow->iSprFntChar);
					} else {
						fprintf(fp, "\t\t0x%04X\t\t\t#//\t\t\t0x%04X\n", pSprFntRow->iSprFntChar, pSprFntRow->iSprFntChar);
					}
					{
						//iSprNoは常にレジストリテーブルに出力する。
						//0(blank)でも出力する。
						//出力を省略する事はしない。
						//もし省略するとキーが空になる可能性が生じて、実行時にエラー判定が出来なくなるからです。
						if(pSprFntRow->iSprNo) {
							fprintf(fp, "\t\t\t%d\t= %d\t#//\t\t\t\t%s\t= %d\n", SprFnt_SprNo, pSprFntRow->iSprNo, "SprNo", pSprFntRow->iSprNo);
						} else {
							fprintf(fp, "\t\t\t%d\t= %d\t#//\t\t\t\t%s\t= %s\n", SprFnt_SprNo, pSprFntRow->iSprNo, "SprNo", "blank");
						}
						//値が省略された(-1)らレジストリテーブルに出力しない。
						//値が省略されなかった(0〜0xFFFFFF)がST_SprFntHdrのデフォルト値(0〜0xFFFFFF)と同じならば、レジストリテーブルに出力しない。
						//実行時は、この文字のキーから値を取得し、値が無ければスプライトフォントのキーの直下からデフォルト値を取得し、それも無ければ暗黙のデフォルト値である0と見なせ。
						if((pSprFntRow->iNextX != -1) && (pSprFntRow->iNextX != pSprFntHdr->iNextX)) { fprintf(fp, "\t\t\t%d\t= %d\t#//\t\t\t\t%s\t= %d\n", SprFnt_NextX, pSprFntRow->iNextX, "NextX", pSprFntRow->iNextX << 8 >> 8); }
						if((pSprFntRow->iNextY != -1) && (pSprFntRow->iNextY != pSprFntHdr->iNextY)) { fprintf(fp, "\t\t\t%d\t= %d\t#//\t\t\t\t%s\t= %d\n", SprFnt_NextY, pSprFntRow->iNextY, "NextY", pSprFntRow->iNextY << 8 >> 8); }
						if((pSprFntRow->iDrawX != -1) && (pSprFntRow->iDrawX != pSprFntHdr->iDrawX)) { fprintf(fp, "\t\t\t%d\t= %d\t#//\t\t\t\t%s\t= %d\n", SprFnt_DrawX, pSprFntRow->iDrawX, "DrawX", pSprFntRow->iDrawX << 8 >> 8); }
						if((pSprFntRow->iDrawY != -1) && (pSprFntRow->iDrawY != pSprFntHdr->iDrawY)) { fprintf(fp, "\t\t\t%d\t= %d\t#//\t\t\t\t%s\t= %d\n", SprFnt_DrawY, pSprFntRow->iDrawY, "DrawY", pSprFntRow->iDrawY << 8 >> 8); }
					}
					fprintf(fp, "\t\t%s\t\t\t#//\t\t\t%s\n", "end", "end");
				}
			}
			fprintf(fp, "\t%s\t\t\t\t#//\t\t%s\n", "end", "end");
		}
	}
	fprintf(fp, "%s\t\t\t\t\t#//\t%s\n", "end", "end");
}
